"""autogenerated by genpy from art_msgs/IOadrState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class IOadrState(genpy.Message):
  _md5sum = "990cf1675736cc78e57b4a0463dd540e"
  _type = "art_msgs/IOadrState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# NCD IOADR8x controller state message for ART vehicle

# $Id: IOadrState.msg 644 2010-09-28 03:19:07Z jack.oquin $

Header  header

# constant bit values for relays and digitalB inputs
uint8 ENABLED      =   1
uint8 RUN          =   2
uint8 FLASHER      =   4
uint8 ALARM        =   8
uint8 LASER_FRONT  =  16
uint8 LASER_TOP    =  32
uint8 TURN_LEFT    =  64
uint8 TURN_RIGHT   = 128

uint8   relays                  # current relays settings

uint8   digitalB                # digital input B

# generally, voltages[0] is the steering position sensor
int32 N_VOLTAGES = 3            # number of analog voltages
float32[3] voltages             # analog voltages [A, B, C]

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  # Pseudo-constants
  ENABLED = 1
  RUN = 2
  FLASHER = 4
  ALARM = 8
  LASER_FRONT = 16
  LASER_TOP = 32
  TURN_LEFT = 64
  TURN_RIGHT = 128
  N_VOLTAGES = 3

  __slots__ = ['header','relays','digitalB','voltages']
  _slot_types = ['std_msgs/Header','uint8','uint8','float32[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,relays,digitalB,voltages

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(IOadrState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.relays is None:
        self.relays = 0
      if self.digitalB is None:
        self.digitalB = 0
      if self.voltages is None:
        self.voltages = [0.,0.,0.]
    else:
      self.header = std_msgs.msg.Header()
      self.relays = 0
      self.digitalB = 0
      self.voltages = [0.,0.,0.]

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.relays, _x.digitalB))
      buff.write(_struct_3f.pack(*self.voltages))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.relays, _x.digitalB,) = _struct_2B.unpack(str[start:end])
      start = end
      end += 12
      self.voltages = _struct_3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.relays, _x.digitalB))
      buff.write(self.voltages.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.relays, _x.digitalB,) = _struct_2B.unpack(str[start:end])
      start = end
      end += 12
      self.voltages = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3f = struct.Struct("<3f")
_struct_2B = struct.Struct("<2B")
